/// <reference types="node" />
import { IncomingMessage, ServerResponse } from 'http';
/**
 * The Context object for the Handler Pipeline
 */
export declare class Context<DATA extends Record<string, any> = {}> {
    /** The IncomingMessage object */
    request: IncomingMessage;
    /** The ServerResponse object */
    response: ServerResponse;
    data: DATA;
    /**
     * The Context constructor
     * @param request - an incoming request
     * @param response - an outgoing response
     */
    constructor(request: IncomingMessage, response: ServerResponse, initialData?: DATA);
}
//# sourceMappingURL=Context.d.ts.map