"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NonStringViewError = exports.NoViewMiddlewareError = exports.NoViewTemplateError = exports.NotFoundError = exports.SierraError = exports.ErrorMessage = void 0;
var ErrorMessage;
(function (ErrorMessage) {
    ErrorMessage["NotFound"] = "not found";
    ErrorMessage["NoViewMiddleware"] = "No view middleware";
    ErrorMessage["NoViewTemplate"] = "no view template";
    ErrorMessage["NonStringView"] = "non string view";
})(ErrorMessage = exports.ErrorMessage || (exports.ErrorMessage = {}));
class SierraError extends Error {
    constructor(message) {
        super(message);
    }
}
exports.SierraError = SierraError;
class NotFoundError extends SierraError {
    constructor() {
        super(ErrorMessage.NotFound);
    }
}
exports.NotFoundError = NotFoundError;
class NoViewTemplateError extends SierraError {
    constructor(template) {
        super(ErrorMessage.NoViewTemplate);
        this.template = template;
    }
}
exports.NoViewTemplateError = NoViewTemplateError;
class NoViewMiddlewareError extends SierraError {
    constructor() {
        super(ErrorMessage.NoViewMiddleware);
    }
}
exports.NoViewMiddlewareError = NoViewMiddlewareError;
class NonStringViewError extends SierraError {
    constructor(output) {
        super(ErrorMessage.NonStringView);
        this.output = output;
    }
}
exports.NonStringViewError = NonStringViewError;
//# sourceMappingURL=Errors.js.map