"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromiseServer = void 0;
const http_1 = require("http");
class PromiseServer extends http_1.Server {
    constructor(handler) {
        super(handler.callback);
        this.handler = handler;
    }
    start(paramA, paramB, paramC, paramD) {
        return new Promise((resolve, reject) => {
            const startup = () => {
                this.on('error', onError);
                this.on('listening', onListening);
            };
            const cleanup = () => {
                this.off('error', onError);
                this.off('listening', onListening);
            };
            const onError = (err) => {
                reject(err);
                cleanup();
            };
            const onListening = () => {
                resolve(this);
                cleanup();
            };
            startup();
            this.listen(paramA, paramB, paramC, paramD);
        });
    }
    /**
     * Closes the `http.Server`.
     */
    exit() {
        return new Promise((resolve, reject) => {
            this.close((error) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve();
                }
            });
        });
    }
    /**
     * Waits for `SIGINT` or `SIGTERM` signals on the `Process` object.
     */
    async wait() {
        return new Promise((resolve) => {
            process.on('SIGINT', () => {
                resolve();
            });
            process.on('SIGTERM', () => {
                resolve();
            });
        });
    }
}
exports.PromiseServer = PromiseServer;
//# sourceMappingURL=PromiseServer.js.map